


import { ContainerModule, interfaces } from 'inversify';
import { TaggedType } from '@common-stack/core';

import { OutputService, OutputMicroservice } from '../services';

import { TYPES } from '../constants';
import { IOutputService, IOutputSettings } from '../interfaces';

export const outputModule: (settings: any) => interfaces.ContainerModule =
    (settings: any) => new ContainerModule((bind: interfaces.Bind) => {
        bind<IOutputService>(TYPES.IOutputService)
            .to(OutputService)
            .inSingletonScope()
            .whenTargetIsDefault();

    });

// export const gitModuleReload: (settings: any) => interfaces.ContainerModule =
//     (settings: any) => new ContainerModule(
//         (bind: interfaces.Bind, unbind: interfaces.Unbind, isBound: interfaces.IsBound, rebind: interfaces.Rebind) => {
//             rebind<IGitModel>(TYPES.IGitModel)
//             .to(GitModel)
//             .inSingletonScope();

//     },
// );


export const outputModuleMicroservice: (settings: any) => interfaces.ContainerModule =
    (settings: any) => new ContainerModule((bind: interfaces.Bind) => {
        bind<IOutputService>(TYPES.IOutputService)
            .to(OutputMicroservice)
            .whenTargetNamed(TaggedType.MICROSERVICE);

        bind<IOutputSettings>(TYPES.IOutputSettings)
            .toConstantValue(settings)
            .whenTargetNamed(TaggedType.MICROSERVICE);
    });
