import { withFilter } from 'graphql-subscriptions';
import { IResolverOptions } from '@common-stack/server-core';
import { IOutputService } from '../../interfaces';

export const resolver: any = (options: IResolverOptions) => ({
  Query: {
    getOutput(root, args, ctx: { outputService: IOutputService }) {
      return ctx.outputService.getOutput(args.request);
    },
    getPods(root, args, ctx: { outputService: IOutputService }) {
      return ctx.outputService.getPods();
    },
  },

  Mutation: {
    unWatchLogs(root, args, ctx: { outputService: IOutputService }) {
          return ctx.outputService.unWatchLogs();
    },
  },

  Subscription: {
    outputDataSubscription: {
      subscribe: withFilter(() => options.pubsub.asyncIterator(`OUTPUT_DATA_SUBSCRIPTIONS`),
        (payload, variables) => {
          if (payload.outputDataSubscription.name === variables.name) {
            return true;
          }
        },
      ),
    },
  },
});
